SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Tests'!

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 16:52'!
initialize
	super initialize.
	self installInputPane.
	self installOutputPane.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:47'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #setInput:.
		inputPane acceptOnCR: true].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:02'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.5 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:04'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.5)).! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil].! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/2/2013 17:52'!
outputText: aText
	self outputContents append: aText.
	self outputContents append: Character cr.
	self changed: #outputContents.! !

!MudTalkClient methodsFor: 'updating' stamp: 'AlexanderSvyazin 1/2/2013 17:52'!
setInput: aText
	|text|
	text := aText copy.
	text addAttribute: (TextColor color: Color red).
	self outputText: text.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 16:34'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client']! !

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !
